;Notice : 	All branches and variables must be position-independent
;		Variables must be acessed via PC
;Original idea of this c2p routine is by Peter McGavin. Thanx.

		;for safety ;-)
		rts

		;Identify string !
		dc.b		'C2P',0
		
		;Main routine		
		;a0 - chunkybuffer
		;a1 - planes
Begin		dc.l		Chunky1x1-Begin		;offset to routine

		;Init routine
		;d0 - Width
		;d1 - Height
		;d2 - PlaneSize
		dc.l		InitChunky-Begin	;offset to routine

		;Supported sizes
		dc.l		Support-Begin
		
InitChunky	lea		Variables(pc),a0
		move.w		d0,d3
		mulu		d1,d3
		move.l		d3,ChunkySize-Variables(a0)
		move.w		d1,Height-Variables(a0)
		move.l		d2,PlaneSize-Variables(a0)
		lsr.w		#3,d0
		move.w		#40,d1
		sub.w		d0,d1
		move.w		d1,Modulo-Variables(a0)
		lsr.w		#2,d0
		move.w		d0,Width32-Variables(a0)
		rts
		
		

plsiz		equ		10240		
Chunky1x1	move.l		ChunkySize(pc),d0
		lea		(a0,d0.l),a2
		move.l		#$00ff00ff,a3
		move.l		#$0f0f0f0f,a4
		bra.s		firstsweep
		cnop		0,16
firstsweep	movem.l		(a0),d0-d7
		move.l		d4,a6
		move.w		d0,d4
		swap		d4
		move.w		d4,d0
		move.w		a6,d4
		move.l		d5,a6
		move.w		d1,d5
		swap		d5
		move.w		d5,d1
		move.w		a6,d5
		move.l		d6,a6
		move.w		d2,d6
		swap		d6
		move.w		d6,d2
		move.w		a6,d6
		move.l		d7,a6
		move.w		d3,d7
		swap		d7
		move.w		d7,d3
		move.w		a6,d7
		move.l		d7,a6
		move.l		d6,a5
		
		move.l		a3,d6
		move.l		d2,d7
		lsr.l		#8,d7
		eor.l		d0,d7
		and.l		d6,d7
		eor.l		d7,d0
		lsl.l		#8,d7
		eor.l		d7,d2
		move.l		d3,d7
		lsr.l		#8,d7
		eor.l		d1,d7
		and.l		d6,d7
		eor.l		d7,d1
		lsl.l		#8,d7
		eor.l		d7,d3
		
		move.l		a4,d6
		move.l		d1,d7
		lsr.l		#4,d7
		eor.l		d0,d7
		and.l		d6,d7
		eor.l		d7,d0
		move.l		d0,(a0)+
		lsl.l		#4,d7
		eor.l		d7,d1
		move.l		d1,(a0)+
		move.l		d3,d7
		lsr.l		#4,d7
		eor.l		d2,d7
		and.l		d6,d7
		eor.l		d7,d2
		move.l		d2,(a0)+
		lsl.l		#4,d7
		eor.l		d7,d3
		move.l		d3,(a0)+
		move.l		a6,d7
		move.l		a5,d6
		
		move.l		a3,d0
		move.l		d6,d1
		lsr.l		#8,d1
		eor.l		d4,d1
		and.l		d0,d1
		eor.l		d1,d4
		lsl.l		#8,d1
		eor.l		d1,d6
		move.l		d7,d1
		lsr.l		#8,d1
		eor.l		d5,d1
		and.l		d0,d1
		eor.l		d1,d5
		lsl.l		#8,d1
		eor.l		d1,d7
		
		move.l		a4,d0
		move.l		d5,d1
		lsr.l		#4,d1
		eor.l		d4,d1
		and.l		d0,d1
		eor.l		d1,d4
		move.l		d4,(a0)+
		lsl.l		#4,d1
		eor.l		d1,d5
		move.l		d5,(a0)+
		move.l		d7,d1
		lsr.l		#4,d1
		eor.l		d6,d1
		and.l		d0,d1
		eor.l		d1,d6
		move.l		d6,(a0)+
		lsl.l		#4,d1
		eor.l		d1,d7
		move.l		d7,(a0)+
		cmp.l		a0,a2
		bne		firstsweep
		
		move.l		PlaneSize(pc),d1
		move.l		ChunkySize(pc),d0
		sub.l		d0,a0
		move.l		#$33333333,d5
		move.l		#$55555555,d6
		lea		(a1,d1.l*4),a1
		neg.l		d1
		lea		(a1,d1.l),a2
		move.w		Modulo(pc),a3
		move.w		Height(pc),a5
		move.w		#32,a6
		
		move.w		Width32(pc),a4
		subq.w		#1,a4
		bra.s		.linesweep
		
		cnop		0,16
		
.linesweep	move.w		a4,d4
.secondsweep	move.l		(a0),d0
		move.l		16(a0),d2
		move.l		d2,d7
		lsr.l		#2,d7
		move.l		8(a0),d1
		eor.l		d0,d7
		and.l		d5,d7
		eor.l		d7,d0
		move.l		24(a0),d3
		lsl.l		#2,d7
		eor.l		d7,d2
		move.l		d3,d7
		lsr.l		#2,d7
		eor.l		d1,d7
		and.l		d5,d7
		eor.l		d7,d1
		lsl.l		#2,d7
		eor.l		d7,d3
		
		move.l		d1,d7
		lsr.l		#1,d7
		eor.l		d0,d7
		and.l		d6,d7
		eor.l		d7,d0
		move.l		d0,plsiz*3(a1)
		add.l		d7,d7
		eor.l		d7,d1
		move.l		d1,plsiz*2(a1)
		move.l		d3,d7
		lsr.l		#1,d7
		eor.l		d2,d7
		and.l		d6,d7
		eor.l		d7,d2
		move.l		d2,plsiz*1(a1)
		add.l		d7,d7
		eor.l		d7,d3
		move.l		d3,(a1)+
		move.l		4(a0),d0
		move.l		20(a0),d2
		move.l		d2,d7
		lsr.l		#2,d7
		move.l		12(a0),d1
		eor.l		d0,d7
		and.l		d5,d7
		move.l		28(a0),d3
		eor.l		d7,d0
		lsl.l		#2,d7
		eor.l		d7,d2
		move.l		d3,d7
		lsr.l		#2,d7
		eor.l		d1,d7
		and.l		d5,d7
		eor.l		d7,d1
		lsl.l		#2,d7
		eor.l		d7,d3
		move.l		d1,d7
		lsr.l		#1,d7
		eor.l		d0,d7
		and.l		d6,d7
		eor.l		d7,d0
		move.l		d0,(a2)+
		add.l		d7,d7
		eor.l		d7,d1
		move.l		d1,-4-plsiz*1(a2)
		move.l		d3,d7
		lsr.l		#1,d7
		eor.l		d2,d7
		and.l		d6,d7
		eor.l		d7,d2
		move.l		d2,-4-plsiz*2(a2)
		add.l		d7,d7
		eor.l		d7,d3
		move.l		d3,-4-plsiz*3(a2)
		add.l		a6,a0
		dbra		d4,.secondsweep
		add.l		a3,a1			;add modulo
		add.l		a3,a2			;add modulo
		subq.w		#1,a5
		move.w		a5,d3
		bne		.linesweep
		rts

Variables
ChunkySize	ds.l		1
Height		ds.w		1
Width32		ds.w		1
Modulo		ds.w		1
PlaneSize	ds.l		1

Support		dc.b	1
		dc.b	1
		dc.b	1
		dc.b	1
		dc.b	1
